function readProductsTemplate(response, keywords){

    // html for listing products
    read_products_html="";

    // search products form
    read_products_html+="<form id='search-product-form' action='#' method='post'>";
    read_products_html+="<div class='input-group pull-left w-30-pct' ";
    read_products_html+="data-toggle='tooltip' title='Search products.' data-placement='right'>";

        read_products_html+="<input type='text' value=\"" + keywords + "\" name='keywords' class='form-control product-search-keywords' placeholder='Search products...' />";

        read_products_html+="<span class='input-group-btn'>";
            read_products_html+="<button type='submit' class='btn btn-default' type='button'>";
                read_products_html+="<span class='glyphicon glyphicon-search'></span>";
            read_products_html+="</button>";
        read_products_html+="</span>";

    read_products_html+="</div>";
    read_products_html+="</form>";

    // when clicked, it will load the create product form
    read_products_html+="<div id='create-product' class='btn btn-primary pull-right m-b-15px create-product-button'>";
        read_products_html+="<span class='glyphicon glyphicon-plus'></span> Create Product";
    read_products_html+="</div>";

    // export products to csv
    read_products_html+="<a href='http://localhost/api/product/export_csv.php' ";
        read_products_html+="class='btn btn-info pull-right margin-right-1em' ";
        read_products_html+="data-toggle='tooltip' title='Download products.' data-placement='top'>";
        read_products_html+="<span class='glyphicon glyphicon-download-alt'></span> Export CSV";
    read_products_html+="</a>";

    // tell the user if no products found
    if(response.message=="No products found."){
        read_products_html+="<div class='overflow-hidden w-100-pct'>";
            read_products_html+="<div class='alert alert-danger'>No products found.</div>";
        read_products_html+="</div>";
    }

    // display products if they exist
    else{

        // start table
        read_products_html+="<table class='table table-bordered table-hover'>";

            // creating our table heading
            read_products_html+="<tr>";
                read_products_html+="<th class='w-25-pct'>Name</th>";
                read_products_html+="<th class='w-10-pct'>Price</th>";
                read_products_html+="<th class='w-15-pct'>Category</th>";
                read_products_html+="<th class='w-25-pct text-align-center'>Action</th>";
            read_products_html+="</tr>";

        // loop through returned list of data
        $.each(response.records, function(key, val){

            var product={
                "id": val.id,
                "name": val.name,
                "price": val.price,
                "description": val.description,
                "category_id": val.category_id,
                "category_name": val.category_name
            };

            read_products_html+="<tr data-product-id='" + val.id + "'>";
                read_products_html+=getProductRowHtml(product);
            read_products_html+="</tr>";

        });

        //end table
        read_products_html+="</table>";

        // paging
        var pagination_class = keywords==""
                            ? "products-pagination-normal"
                            : "products-pagination-search";
        read_products_html+=getPagination(pagination_class, response);
    }

    // inject to app
    $("#page-content").html(read_products_html);

    // make tooltip work
    $('[data-toggle="tooltip"]').tooltip();

}

function getProductRowHtml(product){

    // creating new table row per record
    var product_row_html="";
        product_row_html+="<td class='product_td'>" + product['name'] + "</td>";
        product_row_html+="<td class='product_td'>$" + product['price'] + "</td>";
        product_row_html+="<td class='product_td' data-category-id='" + product['category_id'] + "'>" + product['category_name'] + "</td>";
        product_row_html+="<td>";

            // we chose to hide description
            product_row_html+="<input type='hidden' value=\"" + product['description'] + "\" />";

            // read product button
            product_row_html+="<button class='btn btn-primary m-r-10px read-one-product-button' data-id='" + product['id'] + "'>";
                product_row_html+="<span class='glyphicon glyphicon-eye-open'></span> Read";
            product_row_html+="</button>";

            // edit button
            product_row_html+="<button class='btn btn-info edit-btn m-r-10px update-product-button' data-id='" + product['id'] + "'>";
                product_row_html+="<span class='glyphicon glyphicon-edit'></span> Edit";
            product_row_html+="</button>";

            // delete button
            product_row_html+="<button class='btn btn-danger delete-product-button' data-id='" + product['id'] + "'>";
                product_row_html+="<span class='glyphicon glyphicon-remove'></span> Delete";
            product_row_html+="</button>";

        product_row_html+="</td>";

    return product_row_html;
}
